
module testbench_lb;

// Inputs
reg flaga;
reg flagb;
reg flagc; //partial flag for IN EP
reg flagd; //full flag
reg clk;

// Outputs
wire [1:0] faddr1;
wire [1:0] faddr2;
wire slrd1;
wire slrd2;
wire slwr1;
wire slwr2;
wire sloe1;
wire sloe2;
reg sync;
reg  reset_from_fx3;
reg [2:0] mode;

// Bidirs
wire [31:0] fdata1;
wire [31:0] fdata2;
reg  [31:0] fdata_out;

// Instantiate the Unit Under Test (UUT)
fpga_master dut (
	.sync(sync),
	.fdata(fdata1), 
	.faddr(faddr1), 
	.slrd(slrd1), 
	.slwr(slwr1),
	.flaga(flaga),
	.flagb(flagb),
	.flagc(flagc), 
	.flagd(flagd), 
	.clk(clk), 
	.sloe(sloe1),
	.mode_p(mode)
);
/*
fpga_master_loopback dut2 (
	.sync(sync),
	.fdata(fdata2), 
	.faddr(faddr2), 
	.slrd(slrd2), 
	.slwr(slwr2),
	.flaga(flaga),
	.flagb(flagb),
	.flagc(flagc), 
	.flagd(flagd), 
	.clk(clk), 
	.sloe(sloe2)
);
*/
initial // Clock generator
begin
    clk = 0;
forever #10 clk = !clk;
end

initial begin
	reset_from_fx3 = 1'b0;
	sync = 0;
	#100
	reset_from_fx3 = 1'b1;
	sync  = 1;
	mode  = 3'd4;
	flaga = 0;
	flagb = 0;
	flagc = 0;
	flagd = 0;
	#100
	flaga = 1;
	flagb = 1;
	flagc = 0;
	flagd = 1;
	#200
	flaga = 1;
	flagb = 0;
	flagc = 1;
	#300
	flagb = 1;
	flagc = 0;
	#500
	flagb = 0;
	flagc = 1;
	#400
	flagb = 1;
	flagc = 0;
	#300
	flagb = 0;
	flagc = 1;
	#400
	flagb = 1;
	flagb = 0;
	#400
	flagb = 0;
	#200
	$finish();

	end
/*   
always@(*)begin
	if(sloe1 != sloe2)begin
		$display("sloe mismatch");
		$finish();
	end	
end

always@(*)begin
	if(slwr1 != slwr2)begin
		$display("slwr mismatch");
		$finish();
	end	
end

always@(*)begin
	if(slrd1 != slrd2)begin
		$display("slrd1=%b, slrd2 =%b slrd mismatch",slrd1 , slrd2);
		$finish();
	end	
end
/*

always@(*)begin
	if(fdata1 != fdata2)begin
		$display("fdata1=%h, fdata2 =%h slrd mismatch",fdata1 ,fdata2);
		$finish();
	end	
end
*/



always@(posedge clk)begin
	fdata_out = $random;
end

assign fdata1 = fdata_out;
assign fdata2 = fdata_out;

endmodule

